/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * QuoteRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class QuoteRequest {
  @SerializedName("partner_key")
  private String partnerKey = null;

  @SerializedName("context")
  private QuoteContext context = null;

  @SerializedName("quoting_criteria")
  private QuotingCriteria quotingCriteria = null;

  @SerializedName("customization_criteria")
  private QuoteCustomizationCriteria customizationCriteria = null;

  @SerializedName("undefined_criteria")
  private UndefinedCriteria undefinedCriteria = null;

  public QuoteRequest partnerKey(String partnerKey) {
    this.partnerKey = partnerKey;
    return this;
  }

   /**
   * Universally unique identifier (UUID) of the partner
   * @return partnerKey
  **/
  @ApiModelProperty(required = true, value = "Universally unique identifier (UUID) of the partner")
  public String getPartnerKey() {
    return partnerKey;
  }

  public void setPartnerKey(String partnerKey) {
    this.partnerKey = partnerKey;
  }

  public QuoteRequest context(QuoteContext context) {
    this.context = context;
    return this;
  }

   /**
   * Get context
   * @return context
  **/
  @ApiModelProperty(value = "")
  public QuoteContext getContext() {
    return context;
  }

  public void setContext(QuoteContext context) {
    this.context = context;
  }

  public QuoteRequest quotingCriteria(QuotingCriteria quotingCriteria) {
    this.quotingCriteria = quotingCriteria;
    return this;
  }

   /**
   * Get quotingCriteria
   * @return quotingCriteria
  **/
  @ApiModelProperty(value = "")
  public QuotingCriteria getQuotingCriteria() {
    return quotingCriteria;
  }

  public void setQuotingCriteria(QuotingCriteria quotingCriteria) {
    this.quotingCriteria = quotingCriteria;
  }

  public QuoteRequest customizationCriteria(QuoteCustomizationCriteria customizationCriteria) {
    this.customizationCriteria = customizationCriteria;
    return this;
  }

   /**
   * Get customizationCriteria
   * @return customizationCriteria
  **/
  @ApiModelProperty(value = "")
  public QuoteCustomizationCriteria getCustomizationCriteria() {
    return customizationCriteria;
  }

  public void setCustomizationCriteria(QuoteCustomizationCriteria customizationCriteria) {
    this.customizationCriteria = customizationCriteria;
  }

  public QuoteRequest undefinedCriteria(UndefinedCriteria undefinedCriteria) {
    this.undefinedCriteria = undefinedCriteria;
    return this;
  }

   /**
   * Get undefinedCriteria
   * @return undefinedCriteria
  **/
  @ApiModelProperty(value = "")
  public UndefinedCriteria getUndefinedCriteria() {
    return undefinedCriteria;
  }

  public void setUndefinedCriteria(UndefinedCriteria undefinedCriteria) {
    this.undefinedCriteria = undefinedCriteria;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QuoteRequest quoteRequest = (QuoteRequest) o;
    return Objects.equals(this.partnerKey, quoteRequest.partnerKey) &&
        Objects.equals(this.context, quoteRequest.context) &&
        Objects.equals(this.quotingCriteria, quoteRequest.quotingCriteria) &&
        Objects.equals(this.customizationCriteria, quoteRequest.customizationCriteria) &&
        Objects.equals(this.undefinedCriteria, quoteRequest.undefinedCriteria);
  }

  @Override
  public int hashCode() {
    return Objects.hash(partnerKey, context, quotingCriteria, customizationCriteria, undefinedCriteria);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QuoteRequest {\n");
    
    sb.append("    partnerKey: ").append(toIndentedString(partnerKey)).append("\n");
    sb.append("    context: ").append(toIndentedString(context)).append("\n");
    sb.append("    quotingCriteria: ").append(toIndentedString(quotingCriteria)).append("\n");
    sb.append("    customizationCriteria: ").append(toIndentedString(customizationCriteria)).append("\n");
    sb.append("    undefinedCriteria: ").append(toIndentedString(undefinedCriteria)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

